local barbackdrop = {edgeFile = "Interface/Tooltips/UI-Tooltip-Border", edgeSize = 12}
-- Create table to store the chi bar frames
MHchibar = {}

MHchibar.mainframe = CreateFrame("Frame", "MHChiBar_MainFrame", UIParent)

-- Set properties for the main frame
MHchibar.mainframe:SetWidth(140)
MHchibar.mainframe:SetHeight(32)
MHchibar.mainframe:SetPoint("CENTER", UIParent, "CENTER")

-- Create frames to use for timer functions
MHtimer = CreateFrame("Frame", "MHtimer", UIParent)
MHfskcheck = CreateFrame("Frame", "MHfskCheck", UIParent) -- To keep checking for flying serpent kick cd until it is active
MHfskcheck:Hide()
MHtimer:Hide()

-- Create event frame to handle major events
MHeventframe = CreateFrame("Frame", "MHEventFrame", UIParent)

------Register Event for initialization-----
MHeventframe:RegisterEvent("ADDON_LOADED")
-------------------Register Events------------------------
MHeventframe:RegisterEvent("PLAYER_REGEN_ENABLED")
MHeventframe:RegisterEvent("PLAYER_REGEN_DISABLED")
MHeventframe:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
MHeventframe:RegisterEvent("PLAYER_TALENT_UPDATE")
MHeventframe:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
MHeventframe:RegisterEvent("PLAYER_TALENT_UPDATE")
MHeventframe:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
MHeventframe:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
MHeventframe:RegisterEvent("UNIT_HEALTH")
MHeventframe:RegisterEvent("UNIT_POWER_FREQUENT")
MHeventframe:RegisterEvent("UNIT_AURA")
MHeventframe:RegisterEvent("PLAYER_TARGET_CHANGED")
MHeventframe:RegisterEvent("PLAYER_FOCUS_CHANGED")
MHeventframe:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
MHeventframe:RegisterEvent("SPELL_UPDATE_CHARGES")

-- Create Stagger Tracker
MHstagger = CreateFrame("Frame", "MHStagger", UIParent)
MHstagger:SetPoint("CENTER")
MHstagger:SetWidth(32)
MHstagger:SetHeight(32)
staggericon = MHstagger:CreateTexture("$parent_Icon")
staggericon:SetTexture("Interface\\Icons\\priest_icon_chakra")
staggericon:SetAllPoints(true)
staggertext = MHstagger:CreateFontString("$parent_Text", "OVERLAY", "GameFontNormal")
staggertext:SetPoint("LEFT", MHstagger, "RIGHT", 5, 0)
staggertext:SetTextColor(1, 1, 1)
staggertext:SetText("")
MHstagger:SetScale(1.25)

-- Create Touch Of Death Notification
MHtodnotification = CreateFrame("Frame", "MHTODNotification", UIParent)
MHtodnotification:SetPoint("CENTER")
MHtodnotification:SetWidth(125)
MHtodnotification:SetHeight(45)
MHtransfernotificationbg = MHtodnotification:CreateTexture("$parent_BG")
MHtransfernotificationbg:SetTexture(0, 0, 0, 0.8)
MHtransfernotificationbg:SetAllPoints(true)
MHtodnotificationtext = MHtodnotification:CreateFontString("$parent_Text", "OVERLAY", "GameFontNormal")
MHtodnotificationtext:SetTextColor(1, 1, 1)
MHtodnotificationtext:SetPoint("CENTER")
MHtodnotificationtext:SetWidth(145)
MHtodnotificationtext:SetTextHeight(16)
MHtodnotificationtext:SetText("|cFFFF0000 Finish Them!")
MHtodnotificationicon = MHtodnotification:CreateTexture("$parent_Icon")
MHtodnotificationicon:SetWidth(45)
MHtodnotificationicon:SetHeight(45)
MHtodnotificationicon:SetPoint("RIGHT", MHtodnotification, "LEFT")
MHtodnotificationicon:SetTexture("Interface\\Icons\\ability_monk_touchofdeath")
MHtodnotification:SetScale(0.8)

-- Create Stat Monitor
MHstats = CreateFrame("Frame", "MonkHelper_StatsFrame", UIParent)
MHstats:SetWidth(125)
MHstats:SetHeight(114)
MHstats:SetPoint("CENTER", UIParent, "CENTER")
MHstatsbg = MHstats:CreateTexture("$parent_BG")
MHstatsbg:SetTexture(0, 0, 0, 0.8)
MHstatsbg:SetPoint("CENTER", MHstats, "CENTER")
MHstatsbg:SetWidth(MHstats:GetWidth() - 5)
MHstatsbg:SetHeight(MHstats:GetHeight() - 5)
MHstatsbg:SetDrawLayer("BACKGROUND")
MHstats:SetBackdrop(barbackdrop)
mhstatsheader = MHstats:CreateFontString("$parent_HeadersText", "OVERLAY", "GameFontNormal")
mhstatsheader:SetPoint("TOPLEFT", MHstats, "TOPLEFT", 5, -5)
mhstatsheader:SetJustifyH("LEFT")
statstext = MHstats:CreateFontString("$parent_Text", "OVERLAY", "GameFontNormal")
statstext:SetJustifyH("RIGHT")
statstext:SetPoint("TOPRIGHT", MHstats, "TOPRIGHT", -5, -5)
MHstats:SetScale(0.9)

-- Create Transfer out of range notification
MHtransfernotification = CreateFrame("Frame", "MHTransferNotification", UIParent)
MHtransfernotification:SetPoint("CENTER")
MHtransfernotification:SetWidth(155)
MHtransfernotification:SetHeight(45)
MHtransfernotificationbg = MHtransfernotification:CreateTexture("$parent_BG")
MHtransfernotificationbg:SetTexture(0, 0, 0, 0.8)
MHtransfernotificationbg:SetAllPoints(true)
MHtransfernotificationtext = MHtransfernotification:CreateFontString("$parent_Text", "OVERLAY", "GameFontNormal")
MHtransfernotificationtext:SetTextColor(1, 1, 1)
MHtransfernotificationtext:SetPoint("CENTER")
MHtransfernotificationtext:SetJustifyH("LEFT")
MHtransfernotificationtext:SetWidth(145)
MHtransfernotificationtext:SetText("|cFFFF0000           WARNING!|r \nTranscendence: Transfer is out of range.")
MHtransfernotificationicon = MHtransfernotification:CreateTexture("$parent_Icon")
MHtransfernotificationicon:SetWidth(45)
MHtransfernotificationicon:SetHeight(45)
MHtransfernotificationicon:SetPoint("RIGHT", MHtransfernotification, "LEFT")
MHtransfernotificationicon:SetTexture("Interface\\Icons\\spell_shaman_spectraltransformation")
MHtransfernotification:SetScale(0.8)

-- Create Desperate Measures notification
MHdesperatemeasuresnotification = CreateFrame("Frame", "MHDesperateMeasuresNotification", UIParent)
MHdesperatemeasuresnotification:SetPoint("CENTER")
MHdesperatemeasuresnotification:SetWidth(155)
MHdesperatemeasuresnotification:SetHeight(45)
MHdesperatemeasuresnotificationbg = MHdesperatemeasuresnotification:CreateTexture("$parent_BG")
MHdesperatemeasuresnotificationbg:SetTexture(0, 0, 0, 0.8)
MHdesperatemeasuresnotificationbg:SetAllPoints(true)
MHdesperatemeasuresnotificationtext = MHdesperatemeasuresnotification:CreateFontString("$parent_Text", "OVERLAY", "GameFontNormal")
MHdesperatemeasuresnotificationtext:SetTextColor(1, 1, 1)
MHdesperatemeasuresnotificationtext:SetPoint("CENTER")
MHdesperatemeasuresnotificationtext:SetJustifyH("LEFT")
MHdesperatemeasuresnotificationtext:SetWidth(145)
MHdesperatemeasuresnotificationtext:SetText("Spam Expel Harm!")
MHdesperatemeasuresnotificationicon = MHdesperatemeasuresnotification:CreateTexture("$parent_Icon")
MHdesperatemeasuresnotificationicon:SetWidth(45)
MHdesperatemeasuresnotificationicon:SetHeight(45)
MHdesperatemeasuresnotificationicon:SetPoint("RIGHT", MHdesperatemeasuresnotification, "LEFT")
MHdesperatemeasuresnotificationicon:SetTexture("Interface\\Icons\\spell_nature_shamanrage")
MHdesperatemeasuresnotification:SetScale(0.8)
MHdesperatemeasuresnotification:Hide()

-- Create Rising Sun Kick Icon
MHrisingsunkick = CreateFrame("Frame", "MHRisingSunKick_MainFrame", UIParent)
MHrisingsunkick:SetWidth(32)
MHrisingsunkick:SetHeight(32)
MHrisingsunkick:SetPoint("CENTER", UIParent, "CENTER")
rskicon = MHrisingsunkick:CreateTexture("RisingSunKickIcon")
rskicon:SetTexture("Interface\\Icons\\ability_monk_risingsunkick")
rskicon:SetAllPoints(MHrisingsunkick)
rskicon:SetDrawLayer("BACKGROUND")
CreateFrame("Cooldown", "MHRSKCD", MHrisingsunkick)
MHRSKCD:SetAllPoints(true)

-- Create Touch Of Karma Icon
MHtouchofkarma = CreateFrame("Frame", "MHTouchOfKarma", UIParent)
MHtouchofkarma:SetWidth(32)
MHtouchofkarma:SetHeight(32)
MHtouchofkarma:SetPoint("CENTER", UIParent, "CENTER")
tokicon = MHtouchofkarma:CreateTexture("$parent_Icon")
tokicon:SetTexture("Interface\\Icons\\ability_monk_touchofkarma")
tokicon:SetAllPoints(MHtouchofkarma)
tokicon:SetDrawLayer("BACKGROUND")
CreateFrame("Cooldown", "MHTOKCD", MHtouchofkarma)
MHTOKCD:SetAllPoints(true)

-- Create Sparring Icon
MHsparring = CreateFrame("Frame", "MHSparring", UIParent)
MHsparring:SetWidth(32)
MHsparring:SetHeight(32)
MHsparring:SetPoint("CENTER", UIParent, "CENTER")
sparicon = MHsparring:CreateTexture("$parent_Icon")
sparicon:SetTexture("Interface\\Icons\\ability_monk_sparring")
sparicon:SetAllPoints(MHsparring)
sparicon:SetDrawLayer("BACKGROUND")
CreateFrame("Cooldown", "MHSPCD", MHsparring)
MHSPCD:SetAllPoints(true)

-- Create Energizing Brew Icon
MHenergizingbrew = CreateFrame("Frame", "MHEnergizingBrew", UIParent)
MHenergizingbrew:SetWidth(32)
MHenergizingbrew:SetHeight(32)
MHenergizingbrew:SetPoint("CENTER", UIParent, "CENTER")
ebicon = MHenergizingbrew:CreateTexture("$parent_Icon")
ebicon:SetTexture("Interface\\Icons\\ability_monk_energizingwine")
ebicon:SetAllPoints(MHenergizingbrew)
ebicon:SetDrawLayer("BACKGROUND")
CreateFrame("Cooldown", "MHEBCD", MHenergizingbrew)
MHEBCD:SetAllPoints(true)

-- Create Tiger Power Icon
MHtigerpower = CreateFrame("Frame", "MHTigerPower_MainFrame", UIParent)
MHtigerpower:SetWidth(32)
MHtigerpower:SetHeight(32)
MHtigerpower:SetPoint("CENTER", UIParent, "CENTER")
tpicon = MHtigerpower:CreateTexture("TigerPowerIcon")
tpicon:SetTexture("Interface\\Icons\\ability_monk_tigerpalm")
tpicon:SetAllPoints(MHtigerpower)
tptext = MHtigerpower:CreateFontString("MHTigerPowerText", "OVERLAY", "GameFontNormal")
tptext:SetPoint("CENTER", MHtigerpower, "BOTTOM", 0, -6)

-- Create Flying Serpent Kick Icon
MHflyingserpentkick = CreateFrame("Frame", "MHFlyingSerpentKick_MainFrame", UIParent)
MHflyingserpentkick:SetWidth(32)
MHflyingserpentkick:SetHeight(32)
MHflyingserpentkick:SetPoint("CENTER", UIParent, "CENTER")
fskicon = MHflyingserpentkick:CreateTexture("FlyingSerpentKickIcon")
fskicon:SetTexture("Interface\\Icons\\ability_monk_flyingdragonkick")
fskicon:SetAllPoints(MHflyingserpentkick)
fsktext = MHflyingserpentkick:CreateFontString("MHFlyingSerpentKickText", "OVERLAY", "GameFontNormal")
fsktext:SetPoint("CENTER", MHflyingserpentkick, "BOTTOM", 0, -6)
CreateFrame("Cooldown", "MHFSKCD", MHflyingserpentkick)
MHFSKCD:SetAllPoints(true)

-- create Brew Tracker
MHbrewtracker = CreateFrame("Frame", "MHBrewTracker_MainFrame", UIParent)
MHbrewtracker:SetWidth(32)
MHbrewtracker:SetHeight(32)
MHbrewtracker:SetPoint("CENTER", UIParent, "CENTER")
bticon = MHbrewtracker:CreateTexture("BrewTrackerIcon")
bticon:SetAllPoints(MHbrewtracker)
bttext = MHbrewtracker:CreateFontString("MHBrewTrackerText", "OVERLAY", "GameFontNormal")
bttext:SetPoint("CENTER", MHbrewtracker, "BOTTOM", 0, -6)
btctext = MHbrewtracker:CreateFontString("MHBrewTrackerCountText", "OVERLAY", "GameFontNormal")
btctext:SetPoint("BOTTOMRIGHT", MHbrewtracker, "BOTTOMRIGHT", -3, 3)
btctext:SetTextHeight(13)
btctext:SetTextColor(1, 1, 1)
CreateFrame("Cooldown", "MHBTCD", MHbrewtracker)
MHBTCD:SetAllPoints(true)

-- create Renewing Mist Icon
MHrenewingmist = CreateFrame("Frame", "MHRenewingMist_MainFrame", UIParent)
MHrenewingmist:SetWidth(32)
MHrenewingmist:SetHeight(32)
MHrenewingmist:SetPoint("CENTER", UIParent, "CENTER")
rmicon = MHrenewingmist:CreateTexture("RenewingMistIcon")
rmicon:SetTexture("Interface\\Icons\\ability_monk_renewingmists")
rmicon:SetAllPoints(MHrenewingmist)
CreateFrame("Cooldown", "MHRMCD", MHrenewingmist)
MHRMCD:SetAllPoints(true)

-- create Dematerialize Icon
MHdematerialize = CreateFrame("Frame", "MHDematerialize", UIParent)
MHdematerialize:SetWidth(32)
MHdematerialize:SetHeight(32)
MHdematerialize:SetPoint("CENTER", UIParent, "CENTER")
dmicon = MHdematerialize:CreateTexture("RenewingMistIcon")
dmicon:SetTexture("Interface\\Icons\\spell_arcane_arcane04")
dmicon:SetAllPoints(MHdematerialize)
CreateFrame("Cooldown", "MHDMCD", MHdematerialize)
MHDMCD:SetAllPoints(true)

-- Create Sanctuary Icon
MHsanctuary = CreateFrame("Frame", "MHSanctuary_MainFrame", UIParent)
MHsanctuary:SetWidth(32)
MHsanctuary:SetHeight(32)
MHsanctuary:SetPoint("CENTER", UIParent, "CENTER")
sancticon = MHsanctuary:CreateTexture("SanctuaryIcon")
sancticon:SetTexture("Interface\\Icons\\monk_ability_summonoxstatue")
sancticon:SetAllPoints(MHsanctuary)
sancttext = MHsanctuary:CreateFontString("MHSanctuaryText", "OVERLAY", "GameFontNormal")
sancttext:SetPoint("CENTER", MHsanctuary, "BOTTOM", 0, -6)
CreateFrame("Cooldown", "MHSOSCD", MHsanctuary)
MHSOSCD:SetAllPoints(true)

-- create Keg Smash icon
MHkegsmash = CreateFrame("Frame", "MHKegSmash_MainFrame", UIParent)
MHkegsmash:SetWidth(32)
MHkegsmash:SetHeight(32)
MHkegsmash:SetPoint("CENTER", UIParent, "CENTER")
ksicon = MHkegsmash:CreateTexture("KegSmashIcon")
ksicon:SetTexture("Interface\\Icons\\achievement_brewery_2")
ksicon:SetAllPoints(MHkegsmash)
CreateFrame("Cooldown", "MHKSCD", MHkegsmash)
MHKSCD:SetAllPoints(true)

-- Create Clash Icon
MHclash = CreateFrame("Frame", "MHClash", UIParent)
MHclash:SetWidth(32)
MHclash:SetHeight(32)
MHclash:SetPoint("CENTER", UIParent, "CENTER")
cicon = MHclash:CreateTexture("$parent_Icon")
cicon:SetTexture("Interface\\Icons\\ability_monk_clashingoxcharge")
cicon:SetAllPoints(MHclash)
cicon:SetDrawLayer("BACKGROUND")
CreateFrame("Cooldown", "MHCCD", MHclash)
MHCCD:SetAllPoints(true)

-- Create Avert Harm Icon
MHavertharm = CreateFrame("Frame", "MHAvertHarm", UIParent)
MHavertharm:SetWidth(32)
MHavertharm:SetHeight(32)
MHavertharm:SetPoint("CENTER", UIParent, "CENTER")
ahicon = MHavertharm:CreateTexture("$parent_Icon")
ahicon:SetTexture("Interface\\Icons\\monk_ability_avertharm")
ahicon:SetAllPoints(MHavertharm)
ahicon:SetDrawLayer("BACKGROUND")
CreateFrame("Cooldown", "MHAHCD", MHavertharm)
MHAHCD:SetAllPoints(true)

-- create Thunder Focus Tea icon
MHthunderfocustea = CreateFrame("Frame", "MHThunderFocusTea_MainFrame", UIParent)
MHthunderfocustea:SetWidth(32)
MHthunderfocustea:SetHeight(32)
MHthunderfocustea:SetPoint("CENTER", UIParent, "CENTER")
tfticon = MHthunderfocustea:CreateTexture("ThunderFocusTeaIcon")
tfticon:SetTexture("Interface\\Icons\\ability_monk_thunderfocustea")
tfticon:SetAllPoints(MHthunderfocustea)
CreateFrame("Cooldown", "MHTFTCD", MHthunderfocustea)
MHTFTCD:SetAllPoints(true)

-- Create Life Cocoon Icon
MHlifecocoon = CreateFrame("Frame", "MHLifeCocoon", UIParent)
MHlifecocoon:SetWidth(32)
MHlifecocoon:SetHeight(32)
MHlifecocoon:SetPoint("CENTER", UIParent, "CENTER")
lcicon = MHlifecocoon:CreateTexture("$parent_Icon")
lcicon:SetTexture("Interface\\Icons\\ability_monk_chicocoon")
lcicon:SetAllPoints(MHlifecocoon)
lcicon:SetDrawLayer("BACKGROUND")
CreateFrame("Cooldown", "MHLCCD", MHlifecocoon)
MHLCCD:SetAllPoints(true)

-- Create Summon Jade Serpent Statue Icon
MHsummonjadeserpentstatue = CreateFrame("Frame", "MHsummonjadeserpentstatue", UIParent)
MHsummonjadeserpentstatue:SetWidth(32)
MHsummonjadeserpentstatue:SetHeight(32)
MHsummonjadeserpentstatue:SetPoint("CENTER", UIParent, "CENTER")
sjssticon = MHsummonjadeserpentstatue:CreateTexture("$parent_Icon")
sjssticon:SetTexture("Interface\\Icons\\ability_monk_summonserpentstatue")
sjssticon:SetAllPoints(MHsummonjadeserpentstatue)
sjssticon:SetDrawLayer("BACKGROUND")
CreateFrame("Cooldown", "MHSJSSCD", MHsummonjadeserpentstatue)
MHSJSSCD:SetAllPoints(true)

-- Create Revival Icon
MHrevive = CreateFrame("Frame", "MHRevive", UIParent)
MHrevive:SetWidth(32)
MHrevive:SetHeight(32)
MHrevive:SetPoint("CENTER", UIParent, "CENTER")
ricon = MHrevive:CreateTexture("$parent_Icon")
ricon:SetTexture("Interface\\Icons\\spell_shaman_blessingofeternals")
ricon:SetAllPoints(MHrevive)
ricon:SetDrawLayer("BACKGROUND")
CreateFrame("Cooldown", "MHRCD", MHrevive)
MHRCD:SetAllPoints(true)

-- Create Serpent's Zeal Icon
MHserpentszeal = CreateFrame("Frame", "MHSerpentsZeal_MainFrame", UIParent)
MHserpentszeal:SetWidth(32)
MHserpentszeal:SetHeight(32)
MHserpentszeal:SetPoint("CENTER", UIParent, "CENTER")
szicon = MHserpentszeal:CreateTexture("TigerPowerIcon")
szicon:SetTexture("Interface\\Icons\\ability_monk_ascension")
szicon:SetAllPoints(MHserpentszeal)
sztext = MHserpentszeal:CreateFontString("$parent_Text", "OVERLAY", "GameFontNormal")
sztext:SetPoint("CENTER", MHserpentszeal, "BOTTOM", 0, -6)
MHserpentszeal:Hide()


-- create Fists of Fury icon
MHfistsoffury = CreateFrame("Frame", "MHFistsOfFury_MainFrame", UIParent)
MHfistsoffury:SetWidth(32)
MHfistsoffury:SetHeight(32)
MHfistsoffury:SetPoint("CENTER", UIParent, "CENTER")
foficon = MHfistsoffury:CreateTexture("FistsOfFuryIcon")
foficon:SetTexture("Interface\\Icons\\monk_ability_fistoffury")
foficon:SetAllPoints(MHfistsoffury)
CreateFrame("Cooldown", "MHFOFCD", MHfistsoffury)
MHFOFCD:SetAllPoints(true)


-- create Guard icon
MHguard = CreateFrame("Frame", "MHGuard_MainFrame", UIParent)
MHguard:SetWidth(32)
MHguard:SetHeight(32)
MHguard:SetPoint("CENTER", UIParent, "CENTER")
gicon = MHguard:CreateTexture("GuardIcon")
gicon:SetTexture("Interface\\Icons\\ability_monk_guard")
gicon:SetAllPoints(MHguard)
CreateFrame("Cooldown", "MHGCD", MHguard)
MHGCD:SetAllPoints(true)

-- Create Shuffle icon
MHshuffle = CreateFrame("Frame", "MHShuffle_MainFrame", UIParent)
MHshuffle:SetWidth(32)
MHshuffle:SetHeight(32)
MHshuffle:SetPoint("CENTER", UIParent, "CENTER")
sicon = MHshuffle:CreateTexture("ShuffleIcon")
sicon:SetTexture("Interface\\Icons\\ability_monk_shuffle")
sicon:SetAllPoints(true)
stext = MHshuffle:CreateFontString("MHShuffleText", "OVERLAY", "GameFontNormal")
stext:SetPoint("CENTER", MHshuffle, "BOTTOM", 0, -6)


-- create Expel Harm icon
MHexpelharm = CreateFrame("Frame", "MHExpelHarm_MainFrame", UIParent)
MHexpelharm:SetWidth(32)
MHexpelharm:SetHeight(32)
MHexpelharm:SetPoint("CENTER", UIParent, "CENTER")
ehicon = MHexpelharm:CreateTexture("ExpelHarmIcon")
ehicon:SetTexture("Interface\\Icons\\ability_monk_expelharm")
ehicon:SetAllPoints(MHexpelharm)
CreateFrame("Cooldown", "MHEHCD", MHexpelharm)
MHEHCD:SetAllPoints(true)

-- Create Tier 1 talent tracker
MHtier1 = CreateFrame("Frame", "MHTier1", UIParent)
MHtier1:SetWidth(32)
MHtier1:SetHeight(32)
MHtier1:SetPoint("CENTER", UIParent, "CENTER")
t1icon = MHtier1:CreateTexture("$parent_Icon")
t1icon:SetTexture("Interface\\Icons\\ability_monk_tigerslust")
t1icon:SetAllPoints(MHtier1)
t1icon:SetDrawLayer("BACKGROUND")
CreateFrame("Cooldown", "MHT1CD", MHtier1)
MHT1CD:SetAllPoints(true)

-- create Tier 2 talent tracker
MHtier2 = CreateFrame("Frame", "MHTier2_MainFrame", UIParent)
MHtier2:SetWidth(32)
MHtier2:SetHeight(32)
MHtier2:SetPoint("CENTER", UIParent, "CENTER")
t2icon = MHtier2:CreateTexture("Tier2Icon")
t2icon:SetAllPoints(MHtier2)
CreateFrame("Cooldown", "MHT2CD", MHtier2)
MHT2CD:SetAllPoints(true)

-- Create Tier 3 talent tracker
MHtier3 = CreateFrame("Frame", "MHTier3", UIParent)
MHtier3:SetWidth(32)
MHtier3:SetHeight(32)
MHtier3:SetPoint("CENTER", UIParent, "CENTER")
t3icon = MHtier3:CreateTexture("$parent_Icon")
t3icon:SetTexture("Interface\\Icons\\ability_monk_chibrew")
t3icon:SetAllPoints(MHtier3)
t3icon:SetDrawLayer("BACKGROUND")
CreateFrame("Cooldown", "MHT3CD", MHtier3)
MHT3CD:SetAllPoints(true)

-- Create Tier 4 talent tracker
MHtier4 = CreateFrame("Frame", "MHTier4", UIParent)
MHtier4:SetWidth(32)
MHtier4:SetHeight(32)
MHtier4:SetPoint("CENTER", UIParent, "CENTER")
t4icon = MHtier4:CreateTexture("$parent_Icon")
t4icon:SetTexture("Interface\\Icons\\spell_monk_ringofpeace")
t4icon:SetAllPoints(MHtier4)
t4icon:SetDrawLayer("BACKGROUND")
CreateFrame("Cooldown", "MHT4CD", MHtier4)
MHT4CD:SetAllPoints(true)

-- Create Tier 5 talent tracker
MHtier5 = CreateFrame("Frame", "MHTier5", UIParent)
MHtier5:SetWidth(32)
MHtier5:SetHeight(32)
MHtier5:SetPoint("CENTER", UIParent, "CENTER")
t5icon = MHtier5:CreateTexture("$parent_Icon")
t5icon:SetTexture("Interface\\Icons\\spell_monk_diffusemagic")
t5icon:SetAllPoints(MHtier5)
t5icon:SetDrawLayer("BACKGROUND")
CreateFrame("Cooldown", "MHT5CD", MHtier5)
MHT5CD:SetAllPoints(true)

-- Create Tier 6 talent tracker
MHtier6 = CreateFrame("Frame", "MHTier6", UIParent)
MHtier6:SetWidth(32)
MHtier6:SetHeight(32)
MHtier6:SetPoint("CENTER", UIParent, "CENTER")
t6icon = MHtier6:CreateTexture("$parent_Icon")
t6icon:SetTexture("Interface\\Icons\\ability_monk_summontigerstatue")
t6icon:SetAllPoints(MHtier6)
t6icon:SetDrawLayer("BACKGROUND")
CreateFrame("Cooldown", "MHT6CD", MHtier6)
MHT6CD:SetAllPoints(true)

-- create Detox icon
MHdetox = CreateFrame("Frame", "MHDetox_MainFrame", UIParent)
MHdetox:SetWidth(32)
MHdetox:SetHeight(32)
MHdetox:SetPoint("CENTER", UIParent, "CENTER")
dicon = MHdetox:CreateTexture("DetoxIcon")
dicon:SetTexture("Interface\\Icons\\Spell_Holy_DispelMagic")
dicon:SetAllPoints(MHdetox)
CreateFrame("Cooldown", "MHDCD", MHdetox)
MHDCD:SetAllPoints(true)

-- create Roll icon
MHroll = CreateFrame("Frame", "MHRoll", UIParent)
MHroll:SetWidth(32)
MHroll:SetHeight(32)
MHroll:SetPoint("CENTER", UIParent, "CENTER")
rollicon = MHroll:CreateTexture("$parent_Icon")
rollicon:SetTexture("Interface\\Icons\\ability_monk_roll")
rollicon:SetAllPoints(MHroll)
rollcharges = MHroll:CreateFontString("$parent_Charges", "OVERLAY", "GameFontNormal")
rollcharges:SetTextColor(1, 1, 1)
rollcharges:SetPoint("BOTTOMRIGHT", MHroll, "BOTTOMRIGHT", -2, 2)
rollcharges:SetText(0)
CreateFrame("Cooldown", "MHROCD", MHroll)
MHROCD:SetAllPoints(true)

-- create Zen Pilgrimage icon
MHzenpilgrimage = CreateFrame("Frame", "MHZenPilgrimage", UIParent)
MHzenpilgrimage:SetWidth(32)
MHzenpilgrimage:SetHeight(32)
MHzenpilgrimage:SetPoint("CENTER", UIParent, "CENTER")
zpicon = MHzenpilgrimage:CreateTexture("$parent_Icon")
zpicon:SetTexture("Interface\\Icons\\spell_monk_zenpilgrimage")
zpicon:SetAllPoints(MHzenpilgrimage)
CreateFrame("Cooldown", "MHZPCD", MHzenpilgrimage)
MHZPCD:SetAllPoints(true)

-- create Provoke icon
MHprovoke = CreateFrame("Frame", "MHProvoke", UIParent)
MHprovoke:SetWidth(32)
MHprovoke:SetHeight(32)
MHprovoke:SetPoint("CENTER", UIParent, "CENTER")
pricon = MHprovoke:CreateTexture("$parent_Icon")
pricon:SetTexture("Interface\\Icons\\ability_monk_provoke")
pricon:SetAllPoints(MHprovoke)
CreateFrame("Cooldown", "MHPRCD", MHprovoke)
MHPRCD:SetAllPoints(true)

-- create Touch Of Death icon
MHtouchofdeath = CreateFrame("Frame", "MHTouchOfDeath", UIParent)
MHtouchofdeath:SetWidth(32)
MHtouchofdeath:SetHeight(32)
MHtouchofdeath:SetPoint("CENTER", UIParent, "CENTER")
todicon = MHtouchofdeath:CreateTexture("$parent_Icon")
todicon:SetTexture("Interface\\Icons\\ability_monk_touchofdeath")
todicon:SetAllPoints(MHtouchofdeath)
CreateFrame("Cooldown", "MHTODCD", MHtouchofdeath)
MHTODCD:SetAllPoints(true)

-- create Fortifying Brew icon
MHfortifyingbrew = CreateFrame("Frame", "MHFortifyingBrew", UIParent)
MHfortifyingbrew:SetWidth(32)
MHfortifyingbrew:SetHeight(32)
MHfortifyingbrew:SetPoint("CENTER", UIParent, "CENTER")
fbicon = MHfortifyingbrew:CreateTexture("$parent_Icon")
fbicon:SetTexture("Interface\\Icons\\ability_monk_fortifyingale_new")
fbicon:SetAllPoints(MHfortifyingbrew)
CreateFrame("Cooldown", "MHFBCD", MHfortifyingbrew)
MHFBCD:SetAllPoints(true)

-- create Spear Hand Strike icon
MHspearhandstrike = CreateFrame("Frame", "MHSpearHandStrike", UIParent)
MHspearhandstrike:SetWidth(32)
MHspearhandstrike:SetHeight(32)
MHspearhandstrike:SetPoint("CENTER", UIParent, "CENTER")
shsicon = MHspearhandstrike:CreateTexture("$parent_Icon")
shsicon:SetTexture("Interface\\Icons\\ability_monk_spearhand")
shsicon:SetAllPoints(MHspearhandstrike)
CreateFrame("Cooldown", "MHSHSCD", MHspearhandstrike)
MHSHSCD:SetAllPoints(true)

-- create Nimble Brew icon
MHnimblebrew = CreateFrame("Frame", "MHNimbleBrew", UIParent)
MHnimblebrew:SetWidth(32)
MHnimblebrew:SetHeight(32)
MHnimblebrew:SetPoint("CENTER", UIParent, "CENTER")
nbicon = MHnimblebrew:CreateTexture("$parent_Icon")
nbicon:SetTexture("Interface\\Icons\\spell_monk_nimblebrew")
nbicon:SetAllPoints(MHnimblebrew)
CreateFrame("Cooldown", "MHNBCD", MHnimblebrew)
MHNBCD:SetAllPoints(true)

-- create Grapple Weapon icon
MHgrappleweapon = CreateFrame("Frame", "MHGrappleWeapon", UIParent)
MHgrappleweapon:SetWidth(32)
MHgrappleweapon:SetHeight(32)
MHgrappleweapon:SetPoint("CENTER", UIParent, "CENTER")
gwicon = MHgrappleweapon:CreateTexture("$parent_Icon")
gwicon:SetTexture("Interface\\Icons\\ability_warrior_disarm")
gwicon:SetAllPoints(MHgrappleweapon)
CreateFrame("Cooldown", "MHGWCD", MHgrappleweapon)
MHGWCD:SetAllPoints(true)

-- create Zen Meditation icon
MHzenmeditation = CreateFrame("Frame", "MHZenMeditation", UIParent)
MHzenmeditation:SetWidth(32)
MHzenmeditation:SetHeight(32)
MHzenmeditation:SetPoint("CENTER", UIParent, "CENTER")
zmicon = MHzenmeditation:CreateTexture("$parent_Icon")
zmicon:SetTexture("Interface\\Icons\\ability_monk_zenmeditation")
zmicon:SetAllPoints(MHzenmeditation)
CreateFrame("Cooldown", "MHZMCD", MHzenmeditation)
MHZMCD:SetAllPoints(true)

-- create Transcendence icon
MHtranscendence = CreateFrame("Frame", "MHtranscendence", UIParent)
MHtranscendence:SetWidth(32)
MHtranscendence:SetHeight(32)
MHtranscendence:SetPoint("CENTER", UIParent, "CENTER")
ticon = MHtranscendence:CreateTexture("$parent_Icon")
ticon:SetTexture("Interface\\Icons\\monk_ability_transcendence")
ticon:SetAllPoints(MHtranscendence)
CreateFrame("Cooldown", "MHTCD", MHtranscendence)
MHTCD:SetAllPoints(true)

-- create Transcendence: Transfer icon
MHtranscendencetransfer = CreateFrame("Frame", "MHTranscendenceTransfer", UIParent)
MHtranscendencetransfer:SetWidth(32)
MHtranscendencetransfer:SetHeight(32)
MHtranscendencetransfer:SetPoint("CENTER", UIParent, "CENTER")
tticon = MHtranscendencetransfer:CreateTexture("$parent_Icon")
tticon:SetTexture("Interface\\Icons\\spell_shaman_spectraltransformation")
tticon:SetAllPoints(MHtranscendencetransfer)
CreateFrame("Cooldown", "MHTTCD", MHtranscendencetransfer)
MHTTCD:SetAllPoints(true)

-- create Resource Bar
MHresourcebar = CreateFrame("StatusBar", "MHResourceBar", UIParent)
MHresourcebar:SetWidth(100)
MHresourcebar:SetHeight(12)
MHresourcebar:SetPoint("CENTER", UIParent, "CENTER")
MHresourcebar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
MHresourcebarbg = CreateFrame("Frame", "MHResourceBarBG", MHresourcebar)
MHresourcebarbg:SetWidth(106)
MHresourcebarbg:SetHeight(16)
MHresourcebarbg:SetPoint("CENTER", MHresourcebar, "CENTER")
MHresourcebarbg:SetBackdrop(barbackdrop)
MHresourcebarbg:SetBackdropBorderColor(0.5, 0.5, 0.5)
rbtext = MHresourcebar:CreateFontString("RBText", "OVERLAY", "GameFontNormal")
rbtext:SetPoint("CENTER", MHresourcebar, "CENTER")
rbtext:SetTextColor(1, 1, 1)
rbtext:SetTextHeight(12)

-- Create Paralysis Timer
MHparalysis = CreateFrame("Frame", "MHParalysis", UIParent)
MHparalysis:SetWidth(32)
MHparalysis:SetHeight(32)
MHparalysis:SetPoint("CENTER", UIParent, "CENTER")
picon = MHparalysis:CreateTexture("ParalysisIcon")
picon:SetTexture("Interface\\Icons\\ability_monk_paralysis")
picon:SetAllPoints(MHparalysis)
ptext = MHparalysis:CreateFontString("MHParalysisText", "OVERLAY", "GameFontNormal")
ptext:SetPoint("CENTER", MHparalysis, "TOP", 0, 8)
CreateFrame("Cooldown", "MHPCD", MHparalysis)
MHPCD:SetAllPoints(true)

-- create Paralysis monitor
MHpmonitor = CreateFrame("StatusBar", "MHpMonitor", MHparalysis)
MHpmonitor:SetWidth(120)
MHpmonitor:SetHeight(10)
MHpmonitor:SetPoint("BOTTOMLEFT", MHparalysis, "BOTTOMRIGHT")
MHpmonitor:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
MHpmonitor:SetStatusBarColor(0.5, 0.3, 1)
pmtext = MHpmonitor:CreateFontString("PMText", "OVERLAY", "GameFontNormal")
pmtext:SetPoint("CENTER", MHpmonitor, "CENTER")
pmtext:SetTextColor(1, 1, 1)
pmtext:SetTextHeight(11)
pmntext = MHpmonitor:CreateFontString("PMNText", "OVERLAY", "GameFontNormal")
pmntext:SetPoint("LEFT", MHparalysis, "RIGHT", 2, 10)
pmntext:SetTextHeight(9)
MHpmonitorbg = MHparalysis:CreateTexture("MHPMBG", "BACKGROUND")
MHpmonitorbg:SetPoint("TOPLEFT", MHparalysis, "TOPLEFT", -3, 3)
MHpmonitorbg:SetHeight(38)
MHpmonitorbg:SetWidth(160)
MHpmonitorbg:SetTexture(0, 0, 0, 0.8)
MHpmonitorbg:Hide()
MHpmonitor:Hide()

-- create Xuen timer
MHxuen = CreateFrame("Frame", "MHXuen", UIParent)
MHxuen:SetWidth(20)
MHxuen:SetHeight(20)
MHxuen:SetPoint("CENTER", UIParent, "CENTER")
xicon = MHxuen:CreateTexture("XuenIcon")
xicon:SetTexture("Interface\\Icons\\ability_monk_summontigerstatue")
xicon:SetAllPoints(MHxuen)
MHxmonitor = CreateFrame("StatusBar", "MHxMonitor", MHxuen)
MHxmonitor:SetWidth(100)
MHxmonitor:SetHeight(10)
MHxmonitor:SetPoint("BOTTOMLEFT", MHxuen, "BOTTOMRIGHT")
MHxmonitor:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
MHxmonitor:SetStatusBarColor(0, 1, 0.68)
xtext = MHxmonitor:CreateFontString("XText", "OVERLAY", "GameFontNormal")
xtext:SetPoint("CENTER", MHxmonitor, "CENTER", 2, 0)
xtext:SetTextColor(1, 1, 1)
xtext:SetTextHeight(11)
MHxuen:Hide()

-- create Vital Mists timer
MHvitalmists = CreateFrame("Frame", "MHVitalMists", UIParent)
MHvitalmists:SetWidth(32)
MHvitalmists:SetHeight(32)
MHvitalmists:SetPoint("CENTER", UIParent, "CENTER")
MHvmbg = MHvitalmists:CreateTexture("$parent_BG")
MHvmbg:SetTexture(0, 0, 0, 0.7)
MHvmbg:SetWidth(100)
MHvmbg:SetHeight(32)
MHvmbg:SetPoint("LEFT", MHvitalmists, "RIGHT")
MHvmbg:SetDrawLayer("BACKGROUND")
MHvmtext = MHvitalmists:CreateFontString("$parent_Text", "OVERLAY", "GameFontNormal")
MHvmtext:SetPoint("TOP", MHvmbg, "TOP", 0, -5)
MHvmtext:SetText("")
vmicon = MHvitalmists:CreateTexture("$parent_Icon")
vmicon:SetTexture("Interface\\Icons\\ability_shaman_repulsiontotem")
vmicon:SetAllPoints(MHvitalmists)
MHvmtimer = CreateFrame("StatusBar", "MHVMTimer", MHvitalmists)
MHvmtimer:SetWidth(100)
MHvmtimer:SetHeight(10)
MHvmtimer:SetPoint("BOTTOMLEFT", MHvitalmists, "BOTTOMRIGHT")
MHvmtimer:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
vmtext = MHvmtimer:CreateFontString("$parent_Text", "OVERLAY", "GameFontNormal")
vmtext:SetPoint("CENTER", MHvmtimer, "CENTER", 2, 0)
vmtext:SetTextColor(1, 1, 1)
vmtext:SetTextHeight(11)
MHvitalmists:Hide()

-- create Combo Breaker: Blackout Kick timer
MHcbkick = CreateFrame("Frame", "MHCBKick", UIParent)
MHcbkick:SetWidth(32)
MHcbkick:SetHeight(32)
MHcbkick:SetPoint("CENTER", UIParent, "CENTER")
MHcbkickbg = MHcbkick:CreateTexture("$parent_BG")
MHcbkickbg:SetTexture(0, 0, 0, 0.7)
MHcbkickbg:SetWidth(100)
MHcbkickbg:SetHeight(32)
MHcbkickbg:SetPoint("LEFT", MHcbkick, "RIGHT")
MHcbkickbg:SetDrawLayer("BACKGROUND")
MHkicktext = MHcbkick:CreateFontString("$parent_Text", "OVERLAY", "GameFontNormal")
MHkicktext:SetPoint("TOP", MHcbkickbg, "TOP", 0, -5)
MHkicktext:SetText("Blackout Kick!")
kickicon = MHcbkick:CreateTexture("CBKickIcon")
kickicon:SetTexture("Interface\\Icons\\ability_monk_roundhousekick")
kickicon:SetAllPoints(MHcbkick)
MHkicktimer = CreateFrame("StatusBar", "MHKickTimer", MHcbkick)
MHkicktimer:SetWidth(100)
MHkicktimer:SetHeight(10)
MHkicktimer:SetPoint("BOTTOMLEFT", MHcbkick, "BOTTOMRIGHT")
MHkicktimer:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
kicktext = MHkicktimer:CreateFontString("KickText", "OVERLAY", "GameFontNormal")
kicktext:SetPoint("CENTER", MHkicktimer, "CENTER", 2, 0)
kicktext:SetTextColor(1, 1, 1)
kicktext:SetTextHeight(11)
MHcbkick:Hide()

-- create Combo Breaker: Tiger Palm timer
MHcbpalm = CreateFrame("Frame", "MHCBPalm", UIParent)
MHcbpalm:SetWidth(32)
MHcbpalm:SetHeight(32)
MHcbpalm:SetPoint("CENTER", UIParent, "CENTER")
MHcbpalmbg = MHcbpalm:CreateTexture("$parent_BG")
MHcbpalmbg:SetTexture(0, 0, 0, 0.7)
MHcbpalmbg:SetWidth(100)
MHcbpalmbg:SetHeight(32)
MHcbpalmbg:SetPoint("LEFT", MHcbpalm, "RIGHT")
MHcbpalmbg:SetDrawLayer("BACKGROUND")
MHpalmtext = MHcbpalm:CreateFontString("$parent_Text", "OVERLAY", "GameFontNormal")
MHpalmtext:SetPoint("TOP", MHcbpalmbg, "TOP", 0, -5)
MHpalmtext:SetText("Tiger Palm!")
palmicon = MHcbpalm:CreateTexture("CBKickIcon")
palmicon:SetTexture("Interface\\Icons\\ability_monk_tigerpalm")
palmicon:SetAllPoints(MHcbpalm)
MHpalmtimer = CreateFrame("StatusBar", "MHPalmTimer", MHcbpalm)
MHpalmtimer:SetWidth(100)
MHpalmtimer:SetHeight(10)
MHpalmtimer:SetPoint("BOTTOMLEFT", MHcbpalm, "BOTTOMRIGHT")
MHpalmtimer:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
palmtext = MHpalmtimer:CreateFontString("PalmText", "OVERLAY", "GameFontNormal")
palmtext:SetPoint("CENTER", MHpalmtimer, "CENTER", 2, 0)
palmtext:SetTextColor(1, 1, 1)
palmtext:SetTextHeight(11)
MHcbpalm:Hide()


function MonkHelper_CreateUI()
MHchibar.chibubble = {}
MHchibar.texture0 = {} -- Texture for empty chi
MHchibar.texture1 = {} -- Texture for full chi
-- Create the frames that will show current chi
for idx = 1, 5 do
MHchibar.chibubble[idx] = CreateFrame("Frame", "$parent_ChiBubble"..idx, MHchibar.mainframe)
end
-- Set sub frame properties
for idx = 1, 5 do
MHchibar.chibubble[idx]:SetWidth(32)
MHchibar.chibubble[idx]:SetHeight(32)
if idx == 1 then
MHchibar.chibubble[idx]:SetPoint("TOPLEFT", MHchibar.mainframe, "TOPLEFT")
else
MHchibar.chibubble[idx]:SetPoint("TOPLEFT", MHchibar.chibubble[idx-1], "TOPRIGHT", -8, 0)
end
end
-- Create textures for empty/full chi bubbles
for idx = 1, 5 do
MHchibar.texture0[idx] = MHchibar.chibubble[idx]:CreateTexture("Texture0"..idx)
MHchibar.texture1[idx] = MHchibar.chibubble[idx]:CreateTexture("Texture1"..idx)
end
-- Set texture properties
for idx = 1, 5 do
MHchibar.texture0[idx]:SetDrawLayer("ARTWORK", 6)
MHchibar.texture1[idx]:SetDrawLayer("ARTWORK", 7)
MHchibar.texture0[idx]:SetAllPoints(MHchibar.chibubble[idx])
MHchibar.texture1[idx]:SetAllPoints(MHchibar.chibubble[idx])
MHchibar.texture0[idx]:SetTexture("Interface\\Playerframe\\monknopower")
MHchibar.texture1[idx]:SetTexture("Interface\\Playerframe\\monklightpower")
MHchibar.texture1[idx]:Hide()
end
if UnitPowerMax("player", 12) == 4 then
MHchibar.texture0[5]:Hide()
end
MonkHelper_SetupFrame(MHtransfernotification)
MonkHelper_SetupFrame(MHdesperatemeasuresnotification)
MonkHelper_SetupFrame(MHxuen)
MonkHelper_SetupFrame(MHparalysis)
MonkHelper_SetupFrame(MHchibar.mainframe)
MonkHelper_SetupFrame(MHrisingsunkick)
MonkHelper_SetupFrame(MHtigerpower)
MonkHelper_SetupFrame(MHkegsmash)
MonkHelper_SetupFrame(MHrenewingmist)
MonkHelper_SetupFrame(MHthunderfocustea)
MonkHelper_SetupFrame(MHexpelharm)
MonkHelper_SetupFrame(MHtier2)
MonkHelper_SetupFrame(MHfistsoffury)
MonkHelper_SetupFrame(MHdetox)
MonkHelper_SetupFrame(MHguard)
MonkHelper_SetupFrame(MHbrewtracker)
MonkHelper_SetupFrame(MHresourcebar)
MonkHelper_SetupFrame(MHflyingserpentkick)
MonkHelper_SetupFrame(MHshuffle)
MonkHelper_SetupFrame(MHcbkick)
MonkHelper_SetupFrame(MHcbpalm)
MonkHelper_SetupFrame(MHsanctuary)
MonkHelper_SetupFrame(MHstagger)
MonkHelper_SetupFrame(MHserpentszeal)
MonkHelper_SetupFrame(MHvitalmists)
MonkHelper_SetupFrame(MHstats)
MonkHelper_SetupFrame(MHtodnotification)
MonkHelper_SetupFrame(MHtouchofkarma)
MonkHelper_SetupFrame(MHenergizingbrew)
MonkHelper_SetupFrame(MHclash)
MonkHelper_SetupFrame(MHavertharm)
MonkHelper_SetupFrame(MHsummonjadeserpentstatue)
MonkHelper_SetupFrame(MHrevive)
MonkHelper_SetupFrame(MHlifecocoon)
MonkHelper_SetupFrame(MHtier1)
MonkHelper_SetupFrame(MHtier3)
MonkHelper_SetupFrame(MHtier4)
MonkHelper_SetupFrame(MHtier5)
MonkHelper_SetupFrame(MHtier6)
MonkHelper_SetupFrame(MHroll)
MonkHelper_SetupFrame(MHprovoke)
MonkHelper_SetupFrame(MHzenpilgrimage)
MonkHelper_SetupFrame(MHtouchofdeath)
MonkHelper_SetupFrame(MHfortifyingbrew)
MonkHelper_SetupFrame(MHnimblebrew)
MonkHelper_SetupFrame(MHgrappleweapon)
MonkHelper_SetupFrame(MHzenmeditation)
MonkHelper_SetupFrame(MHspearhandstrike)
MonkHelper_SetupFrame(MHtranscendence)
MonkHelper_SetupFrame(MHtranscendencetransfer)
MonkHelper_SetupFrame(MHsparring)
MonkHelper_SetupFrame(MHdematerialize)
end

function MonkHelper_SetupFrame(frame)
frame:SetFrameStrata("MEDIUM")
frame:SetToplevel()
frame:SetScript("OnDragStart", frame.StartMoving)
frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
frame:RegisterForDrag("LeftButton")
frame:EnableMouse(true)
frame:SetMovable(true)
end

function MonkHelper_Checked(arg) -- converts nil(unchecked) or 1(checked)  to true or false
if arg == 1 then
return false
else
return true
end
end

function MonkHelper_LockFrames()
MHsparring:StopMovingOrSizing()
MHsparring:EnableMouse(false)
MHdematerialize:StopMovingOrSizing()
MHdematerialize:EnableMouse(false)
MHtouchofkarma:StopMovingOrSizing()
MHtouchofkarma:EnableMouse(false)
MHenergizingbrew:StopMovingOrSizing()
MHenergizingbrew:EnableMouse(false)
MHclash:StopMovingOrSizing()
MHclash:EnableMouse(false)
MHavertharm:StopMovingOrSizing()
MHavertharm:EnableMouse(false)
MHzenpilgrimage:StopMovingOrSizing()
MHzenpilgrimage:EnableMouse(false)
MHtouchofdeath:StopMovingOrSizing()
MHtouchofdeath:EnableMouse(false)
MHfortifyingbrew:StopMovingOrSizing()
MHfortifyingbrew:EnableMouse(false)
MHnimblebrew:StopMovingOrSizing()
MHnimblebrew:EnableMouse(false)
MHspearhandstrike:StopMovingOrSizing()
MHspearhandstrike:EnableMouse(false)
MHgrappleweapon:StopMovingOrSizing()
MHgrappleweapon:EnableMouse(false)
MHzenmeditation:StopMovingOrSizing()
MHzenmeditation:EnableMouse(false)
MHtranscendence:StopMovingOrSizing()
MHtranscendence:EnableMouse(false)
MHtranscendencetransfer:StopMovingOrSizing()
MHtranscendencetransfer:EnableMouse(false)
MHlifecocoon:StopMovingOrSizing()
MHlifecocoon:EnableMouse(false)
MHsummonjadeserpentstatue:StopMovingOrSizing()
MHsummonjadeserpentstatue:EnableMouse(false)
MHrevive:StopMovingOrSizing()
MHrevive:EnableMouse(false)
MHtier1:StopMovingOrSizing()
MHtier1:EnableMouse(false)
MHtier3:StopMovingOrSizing()
MHtier3:EnableMouse(false)
MHtier4:StopMovingOrSizing()
MHtier4:EnableMouse(false)
MHtier5:StopMovingOrSizing()
MHtier5:EnableMouse(false)
MHtier6:StopMovingOrSizing()
MHtier6:EnableMouse(false)
MHroll:StopMovingOrSizing()
MHroll:EnableMouse(false)
MHprovoke:StopMovingOrSizing()
MHprovoke:EnableMouse(false)
MHtodnotification:StopMovingOrSizing()
MHtodnotification:EnableMouse(false)
MHstats:StopMovingOrSizing()
MHstats:EnableMouse(false)
MHvitalmists:StopMovingOrSizing()
MHvitalmists:EnableMouse(false)
MHserpentszeal:StopMovingOrSizing()
MHserpentszeal:EnableMouse(false)
MHstagger:StopMovingOrSizing()
MHstagger:EnableMouse(false)
MHsanctuary:StopMovingOrSizing()
MHsanctuary:EnableMouse(false)
MHcbkick:StopMovingOrSizing()
MHcbkick:EnableMouse(false)
MHcbpalm:StopMovingOrSizing()
MHcbpalm:EnableMouse(false)
MHtransfernotification:StopMovingOrSizing()
MHtransfernotification:EnableMouse(false)
MHdesperatemeasuresnotification:StopMovingOrSizing()
MHdesperatemeasuresnotification:EnableMouse(false)
MHxuen:StopMovingOrSizing()
MHxuen:EnableMouse(false)
MHchibar.mainframe:StopMovingOrSizing()
MHchibar.mainframe:EnableMouse(false)
MHresourcebar:StopMovingOrSizing()
MHresourcebar:EnableMouse(false)
MHparalysis:StopMovingOrSizing()
MHparalysis:EnableMouse(false)
MHrisingsunkick:StopMovingOrSizing()
MHrisingsunkick:EnableMouse(false)
MHtigerpower:StopMovingOrSizing()
MHtigerpower:EnableMouse(false)
MHbrewtracker:StopMovingOrSizing()
MHbrewtracker:EnableMouse(false)
MHkegsmash:StopMovingOrSizing()
MHkegsmash:EnableMouse(false)
MHshuffle:StopMovingOrSizing()
MHshuffle:EnableMouse(false)
MHrenewingmist:StopMovingOrSizing()
MHrenewingmist:EnableMouse(false)
MHthunderfocustea:StopMovingOrSizing()
MHthunderfocustea:EnableMouse(false)
MHexpelharm:StopMovingOrSizing()
MHexpelharm:EnableMouse(false)
MHtier2:StopMovingOrSizing()
MHtier2:EnableMouse(false)
MHfistsoffury:StopMovingOrSizing()
MHfistsoffury:EnableMouse(false)
MHguard:StopMovingOrSizing()
MHguard:EnableMouse(false)
MHdetox:StopMovingOrSizing()
MHdetox:EnableMouse(false)
MHflyingserpentkick:StopMovingOrSizing()
MHflyingserpentkick:EnableMouse(false)
end

function MonkHelper_UnlockFrames()
MHsparring:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHdematerialize:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHtouchofkarma:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHenergizingbrew:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHclash:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHavertharm:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHlifecocoon:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHsummonjadeserpentstatue:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHrevive:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHtier1:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHtier3:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHtier4:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHtier5:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHtier6:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHroll:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHprovoke:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHzenpilgrimage:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHtouchofdeath:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHfortifyingbrew:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHnimblebrew:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHspearhandstrike:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHgrappleweapon:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHzenmeditation:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHtranscendence:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHtranscendencetransfer:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHtodnotification:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHstats:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHvitalmists:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHserpentszeal:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHstagger:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHsanctuary:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHcbkick:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHcbpalm:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHtransfernotification:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHdesperatemeasuresnotification:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHxuen:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHchibar.mainframe:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHresourcebar:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHparalysis:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHrisingsunkick:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHtigerpower:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHbrewtracker:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHkegsmash:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHshuffle:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockfrfames))
MHrenewingmist:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHthunderfocustea:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHexpelharm:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHtier2:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHfistsoffury:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHguard:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHdetox:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHflyingserpentkick:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
end

function MonkHelper_Hide()
MHsparring:Hide()
MHdematerialize:Hide()
MHtouchofkarma:Hide()
MHenergizingbrew:Hide()
MHclash:Hide()
MHavertharm:Hide()
MHlifecocoon:Hide()
MHsummonjadeserpentstatue:Hide()
MHrevive:Hide()
MHtier1:Hide()
MHtier3:Hide()
MHtier4:Hide()
MHtier5:Hide()
MHtier6:Hide()
MHroll:Hide()
MHprovoke:Hide()
MHzenpilgrimage:Hide()
MHtouchofdeath:Hide()
MHfortifyingbrew:Hide()
MHnimblebrew:Hide()
MHspearhandstrike:Hide()
MHgrappleweapon:Hide()
MHzenmeditation:Hide()
MHtranscendence:Hide()
MHtranscendencetransfer:Hide()
MHstats:Hide()
MHstagger:Hide()
MHsanctuary:Hide()
MHchibar.mainframe:Hide()
MHresourcebar:Hide()
MHparalysis:Hide()
MHkegsmash:Hide()
MHguard:Hide()
MHshuffle:Hide()
MHbrewtracker:Hide()
MHtigerpower:Hide()
MHrenewingmist:Hide()
MHthunderfocustea:Hide()
MHrisingsunkick:Hide()
MHfistsoffury:Hide()
MHdetox:Hide()
MHexpelharm:Hide()
MHtier2:Hide()
MHflyingserpentkick:Hide()
MHserpentszeal:Hide()
end

function MonkHelper_Show(frame, value)
if value == 1 then
frame:Show()
else 
frame:Hide()
end
end